#!----------------------------------------------------------------------------------------------
#!----------------------------------------------------------------------------------------------
#TEMPLATE (ARandallChart, 'Al Randall Charting'),FAMILY('CW20')
#CONTROL (AKRChartPrint, 'AKR Add Print Graph button'),REQ(AKRChart),MULTI,WINDOW
  CONTROLS
     BUTTON,AT(,,19,15),SKIP,USE(?PrintChart),ICON(ICON:Print1),#REQ
  END

#BOXED('Add Chart Printing Support')
#PROMPT('Charting Control',CONTROL),%OLEControl,REQ,DEFAULT('?OLE')
#PROMPT('Allow printer selection',CHECK),%AllowPrinterSelect,DEFAULT(0),AT(10)
#ENDBOXED

#AT(%GlobalMap),WHERE(%AllowPrinterSelect=%TRUE)
  INCLUDE('DeviceContext.INC'),ONCE
#ENDAT

#AT(%DataSectionBeforeWindow),WHERE(%AllowPrinterSelect=%TRUE)
CxSAV::Printer   STRING(64)
LP:CxPrinterName CSTRING(65)
CxPrintHDC       LONG
#ENDAT

#AT(%PostWindowEventHandling,'OpenWindow'),PRIORITY(6500)
#IF(%AllowPrinterSelect=%TRUE)
   ?PrintChart{PROP:Tip} = 'Print chart to selected printer'
#ELSE
   ?PrintChart{PROP:Tip} = 'Print chart to default printer'
#ENDIF
! Disable printing?
  IF NOT %OLEControl{PROP:OLE} OR %OLEControl{PROP:Hide}
     ?PrintChart{PROP:Hide} = TRUE
  ELSE
     ?PrintChart{PROP:Hide} = FALSE
  END
#ENDAT

#AT (%ControlEventHandling,'?PrintChart','Accepted'),PRIORITY(6500)
  IF NOT %OLEControl{PROP:Hide}
#EMBED(%AKRB4PrinterSelect,'Before sending to printer')
#IF(%AllowPrinterSelect=%TRUE)
      ! Select the printer
        CxSAV::Printer = PRINTER{PROPPRINT:DEVICE}             ! Save current default printer
        IF PrinterDialog('Select printer for chart')           ! Select a printer
           LP:CxPrinterName = PRINTER{PROPPRINT:DEVICE}        ! Get printer name
           CxPrintHDC = CreateDC(0,ADDRESS(LP:CxPrinterName),0,0)   ! Create device context for selected printer
#EMBED(%AKRB4Draw2Printer,'Before Draw2Printer')
           RCP# = ?OLE{'Draw2Printer(' & CxPrintHDC & ')'}     ! Draw to the selected printer
#EMBED(%AKRAftDraw2Printer,'After Draw2Printer')
           RCD# = DeleteDC(CxPrintHDC)                         ! Delete printer context
        END
        PRINTER{PropPrint:Device} = CxSAV::Printer             ! Restore the default printer
#ELSE
        %OLEControl{'Draw2Printer'}
#ENDIF
#EMBED(%AKRAftPrinterSelect,'After sending to printer')
  END
#ENDAT

#! -------------------------------------------------------------------------
#CONTROL (AKRChartSave, 'AKR Add Save Graph button'),REQ(AKRChart),MULTI,WINDOW
  CONTROLS
     BUTTON,AT(,,19,15),SKIP,USE(?SaveChart),ICON(ICON:Save),#REQ
  END

#BOXED('Add Chart Save Support')
#PROMPT('Charting Control',CONTROL),%OLEControl,REQ,DEFAULT('?OLE')
#PROMPT('Allow "SaveAs" selection',CHECK),%AllowSaveAs,DEFAULT(1),AT(10)
#ENDBOXED

#AT(%DataSectionBeforeWindow)
Cx:FileName   CSTRING(65)
#ENDAT

#AT(%ARKCxAfterChartLoad)
#IF(%AllowSaveAs=%TRUE)
   ?SaveChart{PROP:Tip} = 'Save chart w/ user selected name'
#ELSE
 ! Get name of RMCFile and save the chart as "<RMCFile>.JPG"
   Cx:FileName = ?OLE{'RMCFile'}
   CXI# = INSTRING('.',Cx:FileName,1,1)
   IF CXI#
      Cx:FileName = GP:TempDir & Cx:FileName[1 : CXI#-1] & '-' & CLIP(GP:UserID) & '.JPG'
   ELSE
      Cx:FileName = GP:TempDir & 'Chart-' & CLIP(GP:UserID) & '.JPG'
   END
   ?SaveChart{PROP:Tip} = 'Save chart as<13,10>' & Cx:FileName
#ENDIF
! Allow chart saving?
  IF NOT %OLEControl{PROP:OLE} OR %OLEControl{PROP:Hide}
     ?SaveChart{PROP:Hide} = TRUE
  ELSE
     ?SaveChart{PROP:Hide} = FALSE
  END
#ENDAT

#AT (%ControlEventHandling,'?SaveChart','Accepted'),PRIORITY(6500)
  IF NOT %OLEControl{PROP:Hide}
#EMBED(%AKRB4SaveChart,'Before saving the chart')
#IF(%AllowSaveAs=%TRUE)
      ! SaveAs "xxxxx.jpg" per user selection
        CLEAR(Cx:FileName)
        IF FileDialog('Select Chart filename',Cx:FileName,'JPEG|*.JPG',FILE:KeepDir+FILE:LongName+FILE:Save)
           IF Cx:FileName
              ?OLE{'Draw2File(' & Cx:Filename & ')'}
           END
        END
#ELSE
      ! Save as "<TempDir><RMCFile>.JPG"
        %OLEControl{'Draw2File(' & Cx:FileName & ')'}
#ENDIF
#EMBED(%AKRAftSaveChart,'After saving chart')
  END
#ENDAT

#! -------------------------------------------------------------------------
#EXTENSION (AKRChart, 'AKR Charting Extension'),PROCEDURE,LAST
#BOXED('Add Charting Support')
#Display('Randall Business Systems (c)2006')
#PROMPT('RMC Chart Name*',OPENDIALOG('Pick an RMC chart file','RMC Files|*.RMC')),%ChartName,REQ
#PROMPT('Charting Control*',CONTROL),%OLEControl,REQ,DEFAULT('?OLE')
#PROMPT('Chart Title+',@S50),%ChartTitle
#PROMPT('Num of Points/Col',@N3),%NumLines,DEFAULT(1)
#Display('Pie charts should have 1 point/line')
#PROMPT('Min data cols+',@S50),%MinDataPts,DEFAULT(2)
#PROMPT('Max data cols+',@S50),%MaxDataPts,DEFAULT(24)
#PROMPT('Gen Data Labels',CHECK),%GenLabels,DEFAULT(1),AT(10)
#Prompt('Sort Option',DROP('Asc|Des|No')),%SortOption,Default('Asc')
#PROMPT('Set Max Y-Axis value',CHECK),%SetYAxisMax,DEFAULT(0),AT(10)
#BOXED('Error handling')
#PROMPT('If no charting hide msg',CHECK),%NoCharting,DEFAULT(0),AT(10)
#PROMPT('Display Error Msgs on ',CONTROL),%OLEMsg
#PROMPT('If no data, hide',CONTROL),%NoData
#ENDBOXED
#Display('+Enter Value or !Variable Name')
#DISPLAY('*Required Fields')
#DISPLAY('')
#DISPLAY('1) Add logic at the embed to load data queue')
#DISPLAY('2) DO CxDisplayGraph to display the graph.')
#DISPLAY('')
#ENDBOXED

#AT(%DataSectionAfterWindow)
#DECLARE(%Cnt,LONG)
! Declare values for Charting
LP:CxPos GROUP,PRE()
LP:CxX  LONG
LP:CxY  LONG
LP:CxW  LONG
LP:CxH  LONG
        END
LP:CxChartType   STRING(1)     ! Type of chart (Line, Bar, Pie)
LP:CxDataPoints  SHORT         ! Number of data points
LP:CxMaxDataPts  SHORT         ! Max allowed data points
LP:CxMinDataPts  SHORT         ! Min allowed data points
LP:CxStart       SHORT         ! Starting point
LP:CxEnd         SHORT         ! Ending point
LP:CxIncr        SHORT         ! Increment
#IF(%GenLabels=%TRUE)
LP:CxLblString   CSTRING(501) ! String for Labels
#ENDIF
#IF(%SetYAxisMax=%TRUE)
LP:TotalYAxis LONG
LP:MaxYAxis   LONG
#ENDIF
LP:CxDataStrings  GROUP,PRE()
#LOOP,FOR(%Cnt,1,%NumLines)
LP:CxDataString%Cnt  CSTRING(501)  ! String to hold data values %Cnt
#ENDLOOP
     END

! Queue to contain chart X-Axis Labels and Data 
CxQ:Queue QUEUE,PRE()
CxQ:Record   GROUP
CxQ:Sort           STRING(100)  ! Sort value
CxQ:LabelValue     STRING(100)  ! Label Value
#LOOP,FOR(%Cnt,1,%NumLines)
CxQ:DataValue%Cnt  LONG         ! Data Value %Cnt
#ENDLOOP
             END
          END
#ENDAT

#AT(%PostWindowEventHandling,'OpenWindow'),PRIORITY(5500)
#IF(%OLEMsg<>'')
! Position the error message on top of the charting control
  GETPOSITION(%OLEControl,LP:CxX,LP:CxY,LP:CxW,LP:CxH)
  SETPOSITION(%OLEMsg,LP:CxX,LP:CxY,LP:CxW,LP:CxH)
  %OLEMsg{PROP:FontSize} = 16
  %OLEMsg{PROP:Hide}     = TRUE
#ENDIF

! Do the necessary Charting OCX/DLL exist?
  CLEAR(LP:CxPos)
  IF EXISTS('C:\WINDOWS\SYSTEM32\RMChart.OCX') AND |
     EXISTS('C:\WINDOWS\SYSTEM32\RMChart.DLL')
     %OLEControl{PROP:Create} = 'RMChart.RMChartX'
   ! Save the chart location to reposition when drawing
     IF %OLEControl{PROP:OLE}
        0{PROP:Pixels} = TRUE
        GETPOSITION(%OLEControl,LP:CxX,LP:CxY,LP:CxW,LP:CxH)
        0{PROP:Pixels} = FALSE
     ELSE
#INSERT(%OLEInstall)
     END
  ELSE
#INSERT(%OLEInstall)
  END
#ENDAT

#AT(%EndOfProcedure,)
! Deactivate the charting control and free the chart queue
  IF %OLEControl{PROP:OLE}
     %OLEControl{PROP:Deactivate} = TRUE
     FREE(CxQ:Queue)
  END
#ENDAT

#AT(%ProcedureRoutines)
! Build and display the graph
CxDisplayGraph ROUTINE
! Graphing allowed?
  IF NOT %OLEControl{PROP:OLE}
#IF(%OLEMsg<>'')
#INSERT(%OLEInstall)
#ENDIF
     EXIT
  END

! Does the chart file exist?
  IF NOT EXISTS('%ChartName')
#IF(%OLEMsg<>'')
     %OLEControl{PROP:Hide} = TRUE
     %OLEMsg{PROP:Text}     = 'The RMC Chart file "%ChartName" does not exist!'
     %OLEMsg{PROP:Hide}     = FALSE
#ELSE
     BEEP(BEEP:SystemExclamation)  ;  YIELD()
     CASE MESSAGE('RMC Chart file ''%ChartName'' does not exist!', |
          'Error', ICON:Exclamation, |
           BUTTON:Cancel, BUTTON:Cancel, 0)
     OF BUTTON:Cancel
        EXIT
     END !CASE
#ENDIF
  END

! Load the RMC file; title the graph
  %OLEControl{'RMCFile'} = '%ChartName'

#EMBED(%ARKCxAfterChartLoad,'After Chart is loaded')

! Determine what type of chart we have loaded
  IF %OLEControl{'Region(1).GridLessSeries.SeriesStyle'}<>'GetPropertyFailed'
     LP:CxChartType='P'     ! Pie chart
  ELSIF %OLEControl{'Region(1).BarSeries(1).SeriesType'}<>'GetPropertyFailed'
     LP:CxChartType='B'     ! Bar chart
  ELSIF %OLEControl{'Region(1).LineSeries(1).SeriesType'}<>'GetPropertyFailed'
     LP:CxChartType='L'     ! Line chart
  ELSE
     LP:CxChartType='?'     ! Some other type
  END

#IF(SUB(%ChartTitle,1,1)='!')
  #SET(%ValueConstruct,SUB(%ChartTitle,2,LEN(%ChartTitle)-1))
  %OLEControl{'Region(1).Caption.Titel'} = %ValueConstruct
#ELSIF(%ChartTitle<>'')
  %OLEControl{'Region(1).Caption.Titel'} = '%ChartTitle'
#ENDIF

! Resize graph to fill control area
  %OLEControl{'RMCWidth'}  = LP:CxW
  %OLEControl{'RMCHeight'} = LP:CxH

#EMBED(%ARKCxBeforeQueueLoad,'Load values into data queue')

#IF(%SortOption<>'No')
#IF(%SortOption='Asc')
! Sort data queue into ascending sequence
  SORT(CxQ:Queue,+CxQ:Sort)
#ELSE
! Sort data queue into descending sequence
  SORT(CxQ:Queue,-CxQ:Sort)
#ENDIF
#ENDIF

! Any data to graph?
  LP:CxMinDataPts = %MinDataPts
  IF RECORDS(CxQ:Queue)<LP:CxMinDataPts  ! Fewer data points than minimum?
#IF(%NoData<>'')
     %NoData{PROP:Hide} = TRUE
#ELSE
     %OLEControl{PROP:Hide} = TRUE  ! Hide the control
#IF(%OLEMsg<>'')
     %OLEMsg{PROP:Text} = 'No data or insufficient data points!'
     %OLEMsg{PROP:Hide} = FALSE
#ENDIF
#ENDIF
     EXIT                           ! Exit, nothing to do
  ELSE                              ! We have the minimum data points
     LP:CxEnd = RECORDS(CxQ:Queue)       ! All available
  END

! Do we have too many data points?
  LP:CxMaxDataPts = %MaxDataPts
  IF LP:CxEnd>LP:CxMaxDataPts
     LP:CxStart = LP:CxEnd - LP:CxMaxDataPts + 1
  ELSE
     LP:CxStart = 1
  END

! Pie charts present from high to low; all others from low to high
  IF LP:CxChartType='P'
    LP:CxIncr = -1                ! From high to low
    CxT# = LP:CxEnd                ! Swap start/end values
    LP:CxEnd = LP:CxStart
    LP:CxStart = CxT#
  ELSE
    LP:CxIncr = 1
  END

! Build data and label strings
#IF(%GenLabels=%TRUE)
  CLEAR(LP:CxLblString)   ! Axis labels
#ENDIF
  CLEAR(LP:CxDataStrings) ! Data strings
  CLEAR(LP:CxDataPoints)  ! Number of data points
#IF(%SetYAxisMax=%TRUE)
  CLEAR(LP:MaxYAxis)
#ENDIF

#EMBED(%ARKCxBeforeQueueRead,'Before reading queue values')

! Read the data from the queue and build the label and data strings
  LOOP CxT# = LP:CxStart TO LP:CxEnd BY LP:CxIncr   ! Read the queue in order
     GET(CxQ:Queue,CxT#)
     IF NOT ERRORCODE()

#EMBED(%ARKCxAfterQueueRead,'After reading queue value')

#IF(%SetYAxisMax=%TRUE)
      ! Determine maximum value of the values in this Y-Axis
        CLEAR(LP:TotalYAxis)
#LOOP,FOR(%Cnt,1,%NumLines)
        LP:TotalYAxis += CxQ:DataValue%Cnt
#ENDLOOP
        IF LP:TotalYAxis > LP:MaxYAxis
           LP:MaxYAxis = LP:TotalYAxis
        END
#ENDIF

! Is this first time?
        IF NOT LP:CxDataPoints     ! First time
#EMBED(%AKRCxBeforeLabel,'Before building label')
#IF(%GenLabels=%TRUE)
           IF CxQ:LabelValue
              LP:CxLblString = CLIP(CxQ:LabelValue)
           ELSE
              LP:CxLblString = CLIP(CxQ:Sort)
           END
#ENDIF
#LOOP,FOR(%Cnt,1,%NumLines)
           LP:CxDataString%Cnt = CLIP(LEFT(FORMAT(CxQ:DataValue%Cnt,@N_8),8))
#ENDLOOP
        ELSE
#EMBED(%AKRCxBeforeLabel,'Before building label')
#IF(%GenLabels=%TRUE)
           IF CxQ:LabelValue
              LP:CxLblString = LP:CxLblString & '*' & CLIP(CxQ:LabelValue)
           ELSE
              LP:CxLblString = LP:CxLblString & '*' & CLIP(CxQ:Sort)
           END
#ENDIF
#LOOP,FOR(%Cnt,1,%NumLines)
           LP:CxDataString%Cnt = LP:CxDataString%Cnt & '*' & CLIP(LEFT(FORMAT(CxQ:DataValue%Cnt,@N_8),8))
#ENDLOOP
        END
     ELSE
#EMBED(%AKRCxBeforeLabel,'Before building label')
! Error, simply pass blanks and zeros in strings
#IF(%GenLabels=%TRUE)
        LP:CxLblString = LP:CxLblString & '* '
#ENDIF
#LOOP,FOR(%Cnt,1,%NumLines)
        LP:CxDataString%Cnt = LP:CxDataString%Cnt & '*0'
#ENDLOOP
     END

   ! Number of data points
     LP:CxDataPoints += 1
  END

#EMBED(%ARKCxAfterQueueLoad,'After loading values into strings')

#IF(%OLEMsg<>'')
     %OLEMsg{PROP:Hide} = TRUE
#ENDIF
#IF(%NoData<>'')
     %NoData{PROP:Hide} = FALSE
#END

#IF(%SetYAxisMax=%TRUE)
! Set the maximum value to chart
  %OLEControl{'Region(1).DataAxis(1).MaxValue'}  = LP:MaxYAxis          ! Set MaxValue of Y-Axis
#ENDIF

#EMBED(%ARKB4TickCount,'Before setting TickCount')

! Set number of data points
  IF LP:CxChartType<>'P'
     %OLEControl{'Region(1).LabelAxis.TickCount'}   = LP:CxDataPoints   ! Number of data points
  END

#IF(%GenLabels=%TRUE)
#EMBED(%ARKB4LabelString,'Before passing Label String')
! Send the label string to charting
  IF LP:CxChartType<>'P'
     %OLEControl{'Region(1).LabelAxis.LabelString'} = LP:CxLblString    ! Set the Line/Bar chart labels
  ELSE
     %OLEControl{'Region(1).Legend.LegendString'} = LP:CxLblString      ! Set the Pie chart labels
  END
#ENDIF

! Send the data string to charting
#EMBED(%ARKB4DataString,'Before passing Data String')
#LOOP,FOR(%Cnt,1,%NumLines)
  IF LP:CxChartType='L'
     %OLEControl{'Region(1).LineSeries(%Cnt).DataString'} = LP:CxDataString%Cnt  ! Line Chart
  ELSIF LP:CxChartType='B'
     %OLEControl{'Region(1).BarSeries(%Cnt).DataString'} = LP:CxDataString%Cnt   ! Bar Chart
  ELSIF LP:CxChartType='P'
     %OLEControl{'Region(1).GridlessSeries.DataString'} = LP:CxDataString1       ! Pie Chart
  END
#ENDLOOP

#EMBED(%ARKB4Reposition,'Before Repositioning OLE')

! Reposition the control - just in case
  0{PROP:Pixels} = TRUE
  SETPOSITION(%OLEControl,LP:CxX,LP:CxY,LP:CxW,LP:CxH)
  0{PROP:Pixels} = FALSE

#EMBED(%ARKB4Draw,'Before drawing chart')

! Draw the chart
  %OLEControl{'Draw'}
#ENDAT

#GROUP(%OLEInstall)
#IF(%NoCharting=%TRUE AND %NoData<>'')
   ! Hide the control
    %NoData{PROP:Hide} = TRUE
#ELSE
   ! Display an error message
     %OLEControl{PROP:Hide} = TRUE
#IF(%OLEMsg<>'')
     %OLEMsg{PROP:Text}     = 'RMChart.OCX and RMChart.DLL need to be installed before charting can occur.' & |
                              ' This tool, along with "RMCDesigner", may be download from WWW.RMChart.COM.' & |
                              '<13,10>As of 5/18/06 this is a FREE download.'
     %OLEMsg{PROP:FontSize} = 16
     %OLEMsg{PROP:Hide}     = FALSE
#ENDIF
#ENDIF
